.\"	$NetBSD: ep.4,v 1.35 2007/10/30 20:56:00 christos Exp $
.\"
.\" Copyright (c) 1997 Jonathan Stone
.\" All rights reserved.
.\"
.\" Copyright (c) 1994 Herb Peyerl
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgements:
.\"      This product includes software developed by Herb Peyerl
.\"      This product includes software developed by Jonathan Stone
.\" 4. The name of the author may not be used to endorse or promote products
.\"    derived from this software without specific prior written permission
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd October 30, 2007
.Dt EP 4
.Os
.Sh NAME
.Nm ep
.Nd driver for 3Com EtherLink III Ethernet interfaces
.Sh SYNOPSIS
.Cd "ep0 at isa? port ? irq ?"
.Cd "ep* at isapnp?"
.Cd "ep* at eisa? slot ?"
.Cd "ep* at mca? slot ?"
.Cd "ep* at pci? dev ? function ?"
.Cd "ep* at pcmcia? function ?"
.Sh DESCRIPTION
The
.Nm ep
device driver supports the 3Com EtherLink III family of Ethernet cards.
.Pp
The 3c515 is an ISA 10/100 card with DMA capability.
The chipset is similar to that of the 3c905, with some changes to
make it work with the more limited ISA bus address space.
This card is supported, although DMA is not used.
.Pp
The EISA and PCI 3c59x devices use an older DMA engine which is not
capable of multi-segment DMA.
DMA on these devices is not used.
.Pp
The 3c529 is a MCA device, and doesn't support DMA.
.Pp
The PCI 3c90x devices have multi-segment DMA capability, which is
not supported by the
.Nm
driver.
To use the DMA capabilities of these cards, the
.Xr ex 4
driver must be used.
.Pp
The PCI 3c90xB devices are not supported by the
.Nm
driver, as they do not include support for programmed I/O.
These devices are supported by the
.Xr ex 4
driver.
.Pp
The 3c575 is a CardBus device, and is supported by
.Xr ex 4
driver.
.Sh MEDIA SELECTION
There are 3 main chipset classes supported by the
.Nm
driver.
Each has their own media selection capabilities.
.Pp
The first class is the
.Dq 3c509
class.
This includes the 3c509, 3c509B, 3c529, 3c579, 3c562, and 3c589.
These devices can support 10BASE-T, 10BASE2, and 10BASE5.
Available media will be displayed when the device is found by the kernel.
.Pp
The second class is the
.Dq Vortex
class.
This includes the 3c592, 3c579, 3c590, and 3c595.
This class also includes the 3c900-TPO and 3c900-COMBO; they use the
.Dq Boomerang
chipset, but use Vortex-style media selection.
These devices have many different media types varying by model.
Some models have an external MII connector for connecting an external
PHY.
This is supported by means of the
.Dq manual
media type.
Available media will be displayed when the device is found by the kernel.
.Pp
The third class is the
.Dq Boomerang
class.
This includes the 3c515, 3c905, and 3c574.
These devices support media selection via MII.
The 3c515 and 3c905 have an
.Xr nsphy 4 ,
and the 3c574 has a
.Xr tqphy 4 ,
for this purpose.
See
.Xr ifmedia 4
and
.Xr mii 4
for more information.
.Sh HARDWARE
Supported cards include:
.Pp
.Bl -tag -width xxxxxx -offset indent
.It 3c509
ISA 10Mbps card, in BNC and multiport variants
.It 3c509B
ISA Plug-and-Play 10Mbps card, in BNC and multiport variants
.It 3c515
ISA Plug-and-Play 10/100 card with UTP
.It 3c529
MCA 10Mbps card, in UTP+AUI and BNC+AUI variants
.It 3c556B
PCMCIA 56K modem-10/100Mbps Ethernet combo card with dongle
.It 3c562
PCMCIA modem-10Mbps Ethernet combo card with dongle
.It 3c574
PCMCIA 10/100Mbps card with dongle
.It 3c579
EISA 10Mbps card, in UTP, BNC, and multiport variants
.It 3c589
PCMCIA 10Mbps card with dongle
.It 3c590
PCI 10Mbps multiport card with DMA capability
.It 3c592
EISA 10Mbps card with DMA capability
.It 3c595
PCI 10/100Mbps with different media options and DMA capability
.It 3c597
EISA 10/100Mbps card with DMA capability
.It 3c900
PCI 10Mbps card in 10BASE-T and multiport variants with DMA capability
.It 3c905
PCI 10/100Mbps card in 10BASE-T, multiport, and fast variants with
DMA capability
.El
.Sh NOTES
EtherLink III cards have no jumpers to set the address.
3Com supplies software to set the address of the card in software.
To find the card on the ISA bus, the kernel performs a complex
scan operation at IO address 0x100.
.Em Beware !
Avoid placing other cards at that address!
.Pp
The 3Com configuration utilities can `autosense' the active media and
save it as default.
The saved default medium is the medium that
was active at the time the configuration utility was run.
The
.Nm
driver does not yet re-autosense the active media at boot time.
If the EEPROM autosense bit is set, the driver simply uses the media
type sensed and saved when the configuration utility was run.
.Sh DIAGNOSTICS
.Bl -diag
.It "ep0: reset (status: %x)"
the driver has encountered a FIFO underrun or overrun.
The driver will reset the card and the packet will be lost.
This is not fatal.
.It "ep0: eeprom failed to come ready"
The EEPROM failed to come ready.
This probably means the card is wedged.
.It "ep0: 3c509 in test mode. Erase pencil mark!"
This means that someone has scribbled with pencil in the test area on the
card.
Erase the pencil mark and reboot.
(This is not a joke).
.El
.Sh SEE ALSO
.Xr eisa 4 ,
.Xr ex 4 ,
.Xr ifmedia 4 ,
.Xr intro 4 ,
.Xr isa 4 ,
.Xr isapnp 4 ,
.Xr mca 4 ,
.Xr mii 4 ,
.Xr nsphy 4 ,
.Xr pci 4 ,
.Xr pcmcia 4 ,
.Xr tqphy 4 ,
.Xr ifconfig 8
